module BLAKE_INTERFACE(
   clk, rst_n, 
   load, fetch, 
   idata, odata, idata32, counter, 
   busy, start, ack, Ld_EN,
   hash0, hash1, hash2, hash3, hash4, hash5, hash6, hash7 
);

//{{{
input clk;
input rst_n;

input load;
input fetch;

input [15:0] idata;
output [15:0] odata;

output start;
input busy;

output ack;

output Ld_EN;
output reg [63:0] counter;
output [31:0] idata32;

input [31:0] hash0;
input [31:0] hash1;
input [31:0] hash2;
input [31:0] hash3;
input [31:0] hash4;
input [31:0] hash5;
input [31:0] hash6;
input [31:0] hash7;
//}}}

//{{{
reg [5:0] count;
reg [15:0] odata_r;

reg [2:0] state;
reg [2:0] next_state;

reg ack_r;

reg [15:0] idata_r;

//}}}

//{{{
assign odata = odata_r;                                     //output
always @(posedge clk or negedge rst_n)begin
   if (~rst_n) odata_r <= 16'h0000;                     //reset
   else begin
      if (state == 3'b011) begin                       //JE^ɑΉďo͎荞ݕω
         if (count == 'h0) odata_r <= hash0[31:16]; 
         else if (count == 'h1) odata_r <= hash0[15:0];
         else if (count == 'h2) odata_r <= hash1[31:16];
         else if (count == 'h3) odata_r <= hash1[15:0];
         else if (count == 'h4) odata_r <= hash2[31:16];
         else if (count == 'h5) odata_r <= hash2[15:0];
         else if (count == 'h6) odata_r <= hash3[31:16];
         else if (count == 'h7) odata_r <= hash3[15:0];
         else if (count == 'h8) odata_r <= hash4[31:16];
         else if (count == 'h9) odata_r <= hash4[15:0];
         else if (count == 'ha) odata_r <= hash5[31:16];
         else if (count == 'hb) odata_r <= hash5[15:0];
         else if (count == 'hc) odata_r <= hash6[31:16];
         else if (count == 'hd) odata_r <= hash6[15:0];
         else if (count == 'he) odata_r <= hash7[31:16];
         else if (count == 'hf) odata_r <= hash7[15:0];
      end
      else odata_r <= odata_r;
   end
end
//}}}

//{{{
assign idata32 = {idata_r,idata};

always @(posedge clk or negedge rst_n) begin
   if (~rst_n) counter <= 0;
   else if ((state == 3'b001) && (count == 0)) counter <= counter + idata;
   else counter <= counter;
end

always @(posedge clk or negedge rst_n) begin
   if (~rst_n) idata_r <= 0;
   else if (state == 3'b001 && count[0]) idata_r <= idata;
   else idata_r <= idata_r;
end

assign Ld_EN = ((state == 3'b001) && ~count[0])? 1:0; 

//}}}

//{{{
always @(posedge clk or negedge rst_n) begin
   if (~rst_n) count <= 0;
   else if ((state == 3'b100) && (count == 6'hf)) count <= 0;
   else if ((state == 3'b001) && (count == 6'h20)) count <= 0;
   else if ((state == 3'b001) || (state == 3'b100)) count <= count + 1;  
   else count <= count;
end
//}}}

//{{{
assign ack = ack_r;
always @(posedge clk or negedge rst_n)begin
   if (~rst_n) ack_r <= 0;                           //reset
   else begin
      if (state == 3'b011) ack_r <= 1;               //fetchpack 
      else if (state == 3'b001) ack_r <= 1;          //loadpack //#ǉ
      else ack_r <= 0;
   end
end
//}}}

//{{{
assign start = ((state == 3'b010) && ack && (count == 6'h00))? 1:0;
//}}}

//{{{
always @(posedge clk or negedge rst_n)begin
	if (~rst_n) state <= 3'b000;
   else state <= next_state;
end

//gH
always @(load or fetch or state or busy) begin    //ꂩ̐MωƂɔ
   case (state)
      3'b000      : begin                         //Xe[g
         if (load) next_state <= 3'b001;                     
         else if (fetch) next_state <= 3'b011;              
         else next_state <= 3'b000;
      end

      3'b001  : next_state <= 3'b010;             //load_ackXe[g ack𐧌

      3'b010  : begin                             //SHA256_coreNXe[g ENHighɂȂ
         if (~busy) next_state <= 3'b000;         //busyHighȂΑҋ@
         else next_state <= 3'b010;
      end
      
      3'b011 : next_state <= 3'b100;              //fetchXe[g odatahash荞 
      
      3'b100  : next_state <= 3'b000;             //cnt <= cnt + 1;

      default: next_state <= 3'b000;
   endcase
end
//}}}


endmodule 
// vim:fdm=marker
